<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEstabelecimentosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEstabelecimentosERP
 * @subpackage Arrays
 */
class ArrayOfEstabelecimentosERP extends AbstractStructArrayBase
{
    /**
     * The EstabelecimentosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EstabelecimentosERP[]
     */
    public $EstabelecimentosERP;
    /**
     * Constructor method for ArrayOfEstabelecimentosERP
     * @uses ArrayOfEstabelecimentosERP::setEstabelecimentosERP()
     * @param \StructType\EstabelecimentosERP[] $estabelecimentosERP
     */
    public function __construct(array $estabelecimentosERP = array())
    {
        $this
            ->setEstabelecimentosERP($estabelecimentosERP);
    }
    /**
     * Get EstabelecimentosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EstabelecimentosERP[]|null
     */
    public function getEstabelecimentosERP()
    {
        return isset($this->EstabelecimentosERP) ? $this->EstabelecimentosERP : null;
    }
    /**
     * Set EstabelecimentosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EstabelecimentosERP[] $estabelecimentosERP
     * @return \ArrayType\ArrayOfEstabelecimentosERP
     */
    public function setEstabelecimentosERP(array $estabelecimentosERP = array())
    {
        foreach ($estabelecimentosERP as $arrayOfEstabelecimentosERPEstabelecimentosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfEstabelecimentosERPEstabelecimentosERPItem instanceof \StructType\EstabelecimentosERP) {
                throw new \InvalidArgumentException(sprintf('The EstabelecimentosERP property can only contain items of \StructType\EstabelecimentosERP, "%s" given', is_object($arrayOfEstabelecimentosERPEstabelecimentosERPItem) ? get_class($arrayOfEstabelecimentosERPEstabelecimentosERPItem) : gettype($arrayOfEstabelecimentosERPEstabelecimentosERPItem)), __LINE__);
            }
        }
        if (is_null($estabelecimentosERP) || (is_array($estabelecimentosERP) && empty($estabelecimentosERP))) {
            unset($this->EstabelecimentosERP);
        } else {
            $this->EstabelecimentosERP = $estabelecimentosERP;
        }
        return $this;
    }
    /**
     * Add item to EstabelecimentosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\EstabelecimentosERP $item
     * @return \ArrayType\ArrayOfEstabelecimentosERP
     */
    public function addToEstabelecimentosERP(\StructType\EstabelecimentosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EstabelecimentosERP) {
            throw new \InvalidArgumentException(sprintf('The EstabelecimentosERP property can only contain items of \StructType\EstabelecimentosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EstabelecimentosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EstabelecimentosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EstabelecimentosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EstabelecimentosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EstabelecimentosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EstabelecimentosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EstabelecimentosERP
     */
    public function getAttributeName()
    {
        return 'EstabelecimentosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEstabelecimentosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
